﻿package
{
    import mx.controls.Image;
    import mx.core.IDataRenderer;
    import mx.core.UIComponent;
    import mx.events.FlexEvent;
	import flash.net.URLRequest;
	import flash.display.Loader;
    import flash.display.Shape;
    import flash.display.Bitmap;
    import flash.display.BitmapData;
    import flash.display.DisplayObject;
    import flash.display.GradientType;
	import flash.events.Event;
    import flash.geom.Matrix;
    import flash.geom.Point;
    import flash.geom.Rectangle;
	import flash.system.Security;
	import flash.system.LoaderContext;
	import flash.system.System;
 	import mx.effects.AnimateProperty;
	import mx.effects.easing.Quadratic;

    public class ImageReflector extends UIComponent
    {
        private var _content:UIComponent;
		private var _invalidatedReflection:Boolean = false; // 鏡面加工したかどうかのフラグ
		private var _imageLoader:Loader = null; // オリジナル画像ローダー
		private var _imageShape:Shape = null;   // 画像の描画領域
		private var _imageShapeBitmap:BitmapData = null; // オリジナル画像データ
		private var _reflectionShapeBitmap:BitmapData = null; // 鏡面画像データ
        public static const maxImageSize:int = 200;
        public static const maxTiltingWidth:int = 100;
        public static const tiltingMargin:int = 20;
		[Bindable]
		public var asinId:String;
		private static var _selectedIndex:int = -1;
		private static var _prevSelect:int = -1;

        public function ImageReflector()
        {
            super();
        }
        override protected function commitProperties():void
        {
			if (_imageLoader == null) {
				initLoader();
			}

            invalidateDisplayList();
        }
		private function initLoader():void 
		{
			var context:LoaderContext = new LoaderContext(true);
			_imageLoader = new Loader(); // Loaderを生成。
			_imageLoader.contentLoaderInfo.addEventListener(Event.COMPLETE, function():void {
					
					_content = UIComponent(new Image());
					Image(_content).width = _imageLoader.width;
					Image(_content).height = _imageLoader.height;
					addChild(_content);
					// ①　実際のコンテンツの描画領域を作成する。
					_imageShape = new Shape();
					_content.addChild(_imageShape);
					// ②　_imageLoaderを描画用のBitmapDataに変換しておく
					_imageShapeBitmap = new BitmapData(_imageLoader.width, _imageLoader.height, true, 0x000000);
					_imageShapeBitmap.draw(_imageLoader);
					// ③　_imageLoaderを鏡面効果で反転させて、BitmapDataに変換しておく
					var reflectionBitmap:Bitmap = createReflectionBitmap(_imageShapeBitmap);
					_reflectionShapeBitmap = new BitmapData(reflectionBitmap.width, reflectionBitmap.height, true, 0x000000);
					_reflectionShapeBitmap.draw(reflectionBitmap);
					// ④　背景描画が完了したら、鏡面効果を作成する。
					_content.addEventListener(FlexEvent.UPDATE_COMPLETE, invalidateReflection);
				}
			);
			_imageLoader.cacheAsBitmap = true;
			_imageLoader.load(new URLRequest("http://ec1.images-amazon.com/images/P/" + asinId + ".09._SL"+maxImageSize+"_SCLZZZZZZZ_.jpg"));
		}
		
        override protected function measure():void
        {
            if(_content != null)
            {
                measuredHeight = _content.getExplicitOrMeasuredHeight() * 2;
				if(selectedIndex == repeaterIndex) {
					measuredWidth = _content.getExplicitOrMeasuredWidth();
				}
				else {
					measuredWidth = tiltingWidth;
				}
            }
        }
        override protected function updateDisplayList(unscaledWidth:Number, unscaledHeight:Number):void
        {
            if(_content && _invalidatedReflection)
            {
				_invalidatedReflection = false;	// 最初だけ描画するようにフラグをオフにする。

				// 描画領域の初期化
				_imageShape.graphics.clear();
				if (repeaterIndex < selectedIndex) {
					transformImage(tiltingWidth);
				}
				else if (repeaterIndex == selectedIndex) {
					transformImage(_content.getExplicitOrMeasuredWidth());
				}
				else  {
					transformImage(tiltingWidth);
				}
            }
        }
        private function invalidateReflection(event:Event):void
        {
			_invalidatedReflection = true;
			invalidateSize();
            invalidateDisplayList();
        }
        private function createReflectionBitmap(target:BitmapData ):Bitmap
        {
			var kFalloff:Number = .9; // 鏡面効果のグラデーション長
			var reflectionBitmap:Bitmap = null;
            var tw:Number = Math.max(1,target.width);
            var th:Number = Math.max(1,target.height);
            var rect: Rectangle = new Rectangle(0, 0, target.width, target.height);
			// ①　グラデーション用の背景パターンを作成。
            var alphaGradientBitmap:BitmapData = new BitmapData(tw, th, true, 0x00000000);
            var gradientMatrix: Matrix = new Matrix();
            var gradientShape: Shape = new Shape();
            gradientMatrix.createGradientBox(tw, th * kFalloff, Math.PI/2, 
                0, th * (1.0 - kFalloff));
            gradientShape.graphics.beginGradientFill(GradientType.LINEAR, [0xFFFFFF, 0xFFFFFF], 
                [0, 1], [0, 255], gradientMatrix);
            gradientShape.graphics.drawRect(0, th * (1.0 - kFalloff), 
                tw, th * kFalloff);
            gradientShape.graphics.endFill();
            alphaGradientBitmap.draw(gradientShape, new Matrix());
			// ②　グラデーション背景と画像を重ね合わせる。
            var reflectionData:BitmapData = new BitmapData(tw, th, false, 0x00000000);									
            reflectionData.fillRect(rect, 0x00000000);
            reflectionData.copyPixels(target, rect, new Point(), alphaGradientBitmap);
			// ③　Bitmapに変換して、透過度を設定。
            reflectionBitmap = new Bitmap(reflectionData);
            reflectionBitmap.alpha = .85;
			return reflectionBitmap;
        }
		[Bindable]
		public function set selectedIndex(value:Number):void
		{
			_prevSelect = _selectedIndex;
			_selectedIndex = value;
		}
		public function get selectedIndex():Number
		{
			return _selectedIndex;
		}
		public function set tiltingWidth(value:Number):void
		{
			// no set
		}
		public function get tiltingWidth():Number
		{
			var contentWidth:Number = _content.getExplicitOrMeasuredWidth();
			var contentHeight:Number = _content.getExplicitOrMeasuredHeight();
			var radians:Number = Math.atan2(-tiltingMargin, maxTiltingWidth);
			var rotation:Number = radians * 180 / Math.PI;
			var w:Number = Math.abs(contentWidth * Math.cos(rotation * 180 / Math.PI));
			return Math.min(maxTiltingWidth, w);
		}
		private function transformImage(value:Number):void {
			var contentWidth:Number = _content.getExplicitOrMeasuredWidth();
			var contentHeight:Number= _content.getExplicitOrMeasuredHeight();
			var index:int = repeaterIndex;
			var select:int = selectedIndex;
			var xm:Number = (maxTiltingWidth - tiltingWidth) / 2;
			var percent:Number = (contentWidth - value) / (contentWidth - tiltingWidth);

			_imageShape.graphics.clear();
			var x1:int, x2:int, y1:int, y2:int, y3:int, y4:int, y5:int, y6:int;
			if (index < select) {
				x1 = xm;
				x2 = value;
				y1 = (maxImageSize - contentHeight) + tiltingMargin * percent;
				y2 = (maxImageSize - contentHeight) + tiltingMargin * 2 * percent;
				y3 = (maxImageSize - contentHeight) + contentHeight - tiltingMargin * 2 * percent;
				y4 = (maxImageSize - contentHeight) + contentHeight - tiltingMargin * percent;
				y5 = y3 + _reflectionShapeBitmap.height - tiltingMargin * 2 * percent;
				y6 = y4 + _reflectionShapeBitmap.height - tiltingMargin;
			}
			else if (index == select) {
				if (_prevSelect > _selectedIndex) { // 左から中央
					x1 = 0;
					x2 = value;
					y1 = (maxImageSize - contentHeight) + tiltingMargin * percent;
					y2 = (maxImageSize - contentHeight) + tiltingMargin * 2 * percent;
					y3 = (maxImageSize - contentHeight) + contentHeight - tiltingMargin * 2 * percent;
					y4 = (maxImageSize - contentHeight) + contentHeight - tiltingMargin * percent;
					y5 = y3 + _reflectionShapeBitmap.height - tiltingMargin * 2 * percent;
					y6 = y4 + _reflectionShapeBitmap.height - tiltingMargin * percent;
				}
				else { // 右から中央
					x1 = 0;
					x2 = value;
					y1 = (maxImageSize - contentHeight) + tiltingMargin * 2 * percent;
					y2 = (maxImageSize - contentHeight) + tiltingMargin * percent;
					y3 = (maxImageSize - contentHeight) + contentHeight - tiltingMargin * percent;
					y4 = (maxImageSize - contentHeight) + contentHeight - tiltingMargin * 2 * percent;
					y5 = y3 + _reflectionShapeBitmap.height - tiltingMargin * percent;
					y6 = y4 + _reflectionShapeBitmap.height - tiltingMargin * 2 * percent;
				}
			}
			else  {
				x1 = xm;
				x2 = value;
				y1 = (maxImageSize - contentHeight) + tiltingMargin * 2 * percent;
				y2 = (maxImageSize - contentHeight) + tiltingMargin * percent;
				y3 = (maxImageSize - contentHeight) + contentHeight - tiltingMargin * percent;
				y4 = (maxImageSize - contentHeight) + contentHeight - tiltingMargin * 2 * percent;
				y5 = y3 + _reflectionShapeBitmap.height - tiltingMargin;
				y6 = y4 + _reflectionShapeBitmap.height - tiltingMargin * 2 * percent;
			}
			drawImageShape(x1, x2, y1, y2, y3, y4, y5, y6);
		}
		
		/*
		 * 
		 * x1,y1
		 *  |\
		 *  | |  x2,y2 
		 *  | |
		 *  | |  x2,y3
		 *  |/
		 * x1,y4
		 *  | |
		 *  | |
		 *  |/   x2,y5
		 * x1,y6
		 * 
		 */
		private function drawImageShape(x1:int, x2:int, y1:int, y2:int, y3:int, y4:int, y5:int, y6:int):void {
			var contentWidth:Number = _content.getExplicitOrMeasuredWidth();
			var contentHeight:Number = _content.getExplicitOrMeasuredHeight();
			
			TransformUtil.drawBitmapQuadrangle(_imageShape.graphics, _imageShapeBitmap, 
				new Point(0, 0), new Point(contentWidth, 0), new Point(0, contentHeight), new Point(contentWidth, contentHeight), 
				new Point(x1, y1), new Point(x2, y2), new Point(x1, y4), new Point(x2, y3), 
				4, 4);
			TransformUtil.drawBitmapQuadrangle(_imageShape.graphics, _reflectionShapeBitmap, 
				new Point(0, 1), new Point(_reflectionShapeBitmap.width, 1), 
					new Point(0, _reflectionShapeBitmap.height), new Point(_reflectionShapeBitmap.width, _reflectionShapeBitmap.height), 
				new Point(x1, y6),  new Point(x2, y5), new Point(x1, y4), new Point(x2, y3),
				4, 4);
		}
		/**
		 * valueが0なら選択に、valueが0以下なら左スクロール（選択の左側になる）、valueが0以上なら右スクロール（選択の右側になる）
		 * @param	value
		 */
		public function doAnimate(value:int):AnimateProperty {
			if (_animation && _animation.isPlaying) {
				_animation.end();
			}
			_animation = new AnimateProperty(this);
			_animation.property = "animateTransform";
			if (value == 0) {
				_animation.toValue = _content.getExplicitOrMeasuredWidth();
				_animation.fromValue = tiltingWidth;
				_animation.easingFunction = mx.effects.easing.Quadratic.easeIn;
			}
			else {
				_animation.fromValue = _content.getExplicitOrMeasuredWidth();
				_animation.toValue = tiltingWidth;
				_animation.easingFunction = mx.effects.easing.Quadratic.easeOut;
			}
			_animation.target = this;
			_animation.duration = 300;
			_animation.play();
			return _animation;
		}
		private	var _animation:AnimateProperty = null;
		private var _animateTransform:Number = 0;
		public function set animateTransform(value:Number):void
		{
			_animateTransform = value;
			
			if (repeaterIndex == selectedIndex) {
				measuredWidth = value;
			}
			else {
				measuredWidth = tiltingWidth;
			}
			invalidateSize();
			transformImage(value);
			
		}
		public function get animateTransform():Number
		{
			return _animateTransform;
		}
		public function isCompleted():Boolean {
			if (!_invalidatedReflection) return false
			
			return true;
		}

	}
}